Bug 1319083 - boot fails with Synchronous Exception on aarch64 with grub2 built with gcc6
Summary: boot fails with Synchronous Exception on aarch64 with grub2 built with gcc6
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: grub2
Version: 24
Hardware: aarch64
OS: Linux
unspecified
unspecified
Target Milestone: ---
Assignee: Peter Jones
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1335654
Blocks: ARM64, F-ExcludeArch-aarch64
TreeView+ depends on / blocked
 
Reported: 2016-03-18 15:42 UTC by Paul Whalen
Modified: 2016-08-21 02:23 UTC (History)
10 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-08-21 02:23:19 UTC


Attachments (Terms of Use)
F23 grub2 root.log (107.77 KB, text/plain)
2016-04-20 09:34 UTC, Peter Robinson
no flags Details
F24 grub2 root.log (113.49 KB, text/plain)
2016-04-20 09:35 UTC, Peter Robinson
no flags Details
F23 grub2 scratch build log (1.84 MB, text/plain)
2016-04-20 09:36 UTC, Peter Robinson
no flags Details
F24 grub2 scratch build log (1.84 MB, text/plain)
2016-04-20 09:37 UTC, Peter Robinson
no flags Details

Description Paul Whalen 2016-03-18 15:42:28 UTC
Description of problem:
BOOTAA64.EFI fails with Synchronous Exception on aarch64

Version-Release number of selected component (if applicable):
shim-unsigned-0.8-2.fc22
grub2-efi-2.02-0.27.fc24.aarch64

How reproducible:
Everytime

Steps to Reproduce:
1. Attempt an install of F24 using PXE or media on any hardware or virt (tested on Seattle, Mustang and QEMU)
http://dl.fedoraproject.org/pub/fedora-secondary/development/24/Everything/aarch64/os/


Actual results:
..Failed to set MokListRT: Invalid Parameter
Fetching Netboot Image


Synchronous Exception at 0x00000043FA1AE4A8
0: FP 0x00000043FFA7EA80 SP 0x00000043FFA7EA80 PC 0x00000043FA1AF050
1: FP 0x00000043FFA7EAC0 SP 0x00000043FFA7EA90 PC 0x00000043FA1AF04C
2: FP 0x00000043FFA7EB00 SP 0x00000043FFA7EAD0 PC 0x00000043FA1AC470
3: FP 0x00000043FFA7EB10 SP 0x00000043FFA7EB10 PC 0x00000043FA1B4C78
4: FP 0x00000043FFA7EB60 SP 0x00000043FFA7EB20 PC 0x00000043FA6B0188
5: FP 0x00000043FFA7EC60 SP 0x00000043FFA7EB70 PC 0x00000043FA6B0218
6: FP 0x00000043FFA7EC90 SP 0x00000043FFA7EC70 PC 0x00000043FA6B102C
7: FP 0x00000043FFA7ECD0 SP 0x00000043FFA7ECA0 PC 0x00000043FA6AC174
8: FP 0x00000043FFA7ECF0 SP 0x00000043FFA7ECE0 PC 0x00000043FFA81BD0
9: FP 0x00000043FFA7ED40 SP 0x00000043FFA7ED00 PC 0x00000043FF99A2DC
10: FP 0x00000043FFA7EDA0 SP 0x00000043FFA7ED50 PC 0x00000043FF993D18
11: FP 0x00000043FFA7EDF0 SP 0x00000043FFA7EDB0 PC 0x00000043FF99388C
12: FP 0x00000043FFA7EE80 SP 0x00000043FFA7EE00 PC 0x00000043FF991D4C
13: FP 0x00000043FFA7EEF0 SP 0x00000043FFA7EE90 PC 0x00000043FFA7F7F4
14: FP 0x00000043FFA7EFE0 SP 0x00000043FFA7EF00 PC 0x00000043FFA7F270


Expected results:
loads grub.cfg

Additional info:
using grubaa64.efi loaded grub.cfg

Comment 1 Paul Whalen 2016-03-22 14:18:12 UTC
grub2-efi-2.02-0.27.fc24 was untagged on arm.koji, yesterdays (03212016) install media worked as expected. 

The resulting install did not boot with 'shim.efi' as noted in bz#1309147, failing to unpack the initrd. When replaced with 'grubaa64.efi' the system boots to log in on the mustang.

Comment 3 Paul Whalen 2016-04-08 19:17:25 UTC
Reopening, this is also happening with grub2-2.02-0.30.fc24 . 

Again I am able to boot with the 'grubaa64.efi', using the default 'shim.efi' results in a syncrhonous exception on both the mustang and seattle.

Comment 4 Paul Whalen 2016-04-08 19:20:17 UTC
Adding Mark for his input.

Comment 5 Paul Whalen 2016-04-14 16:54:23 UTC
When built with F23 tools, grub2-2.02-0.30 works as expected with no Synchronous Exception.

Comment 6 Peter Robinson 2016-04-20 09:32:50 UTC
F23: http://arm.koji.fedoraproject.org/koji/taskinfo?taskID=3509029
F24: http://arm.koji.fedoraproject.org/koji/taskinfo?taskID=3509700

F23:
binutils: 2.25-17.fc23
gcc: 5.3.1-6.fc23
elfutils: 0.166-1.fc23

F24:
binutils: 2.26-14.fc24
gcc: 6.0.0-0.20.fc24
elfutils: 0.166-2.fc24

Comment 7 Peter Robinson 2016-04-20 09:34:56 UTC
Created attachment 1148950 [details]
F23 grub2 root.log

The root.log install from the F23 scratch build

Comment 8 Peter Robinson 2016-04-20 09:35:47 UTC
Created attachment 1148951 [details]
F24 grub2 root.log

The buildroot package install log for the F24 scratch

Comment 9 Peter Robinson 2016-04-20 09:36:52 UTC
Created attachment 1148953 [details]
F23 grub2 scratch build log

The scratch build log built with gcc 5.3.1 on f23

Comment 10 Peter Robinson 2016-04-20 09:37:39 UTC
Created attachment 1148954 [details]
F24 grub2 scratch build log

The scratch build log built with gcc 6 on f24

Comment 11 Jon Masters 2016-05-11 07:58:47 UTC
The shim does a bunch of relocation of the EFI (GRUB2) binary that's probably failing in handle_image. I've just started poking, but what I will do is instrument the code and see where it is falling over.

Comment 12 Jon Masters 2016-05-17 06:12:09 UTC
We determined that the shim had a bad patch and needed upgrading to a newer build. Pending update on status of that.

Comment 13 Peter Robinson 2016-05-17 08:42:43 UTC
We're packaging shim for aarch64 separately so we don't need to keep it in lockstep for x86_64 or ia32. Review done, should be built today and in tomorrow's compose with luck.

Comment 14 Peter Robinson 2016-05-18 10:03:15 UTC
Should be fixed in today's compose:

https://dl.fedoraproject.org/pub/fedora-secondary/development/24/

Comment 15 Peter Robinson 2016-08-21 02:23:19 UTC
Fixed


Note You need to log in before you can comment on or make changes to this bug.